Bug 1901917 - fbthrift fails to build with Python 3.10: relocation R_X86_64_PC32 against symbol `_ZTVSt9basic_iosIcSt11char_traitsIcEE@@GLIBCXX_3.4' can not be used when making a shared object; recompile with -fPIC
Summary: fbthrift fails to build with Python 3.10: relocation R_X86_64_PC32 against sy...
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: fbthrift
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Michel Alexandre Salim
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-26 12:23 UTC by Miro Hrončok
Modified: 2021-02-09 16:24 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Miro Hrončok 2020-11-26 12:23:35 UTC
fbthrift fails to build with Python 3.10.0a2.

[  6%] Linking CXX shared library ../../lib/libmustache_lib.so
cd /builddir/build/BUILD/fbthrift-2020.11.23.00/x86_64-redhat-linux-gnu/thrift/compiler && /usr/bin/cmake -E cmake_link_script CMakeFiles/mustache_lib.dir/link.txt --verbose=1
/usr/bin/g++ -fPIC -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -Wl,-z,relro -Wl,--as-needed  -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -shared -Wl,-soname,libmustache_lib.so.2020.11.23.0 -o ../../lib/libmustache_lib.so.2020.11.23.0 CMakeFiles/mustache_lib.dir/mustache/mstch.cpp.o CMakeFiles/mustache_lib.dir/mustache/render_context.cpp.o CMakeFiles/mustache_lib.dir/mustache/state/in_section.cpp.o CMakeFiles/mustache_lib.dir/mustache/state/outside_section.cpp.o CMakeFiles/mustache_lib.dir/mustache/template_type.cpp.o CMakeFiles/mustache_lib.dir/mustache/token.cpp.o CMakeFiles/mustache_lib.dir/mustache/utils.cpp.o  -lboost_context -lboost_filesystem -lboost_program_options -lboost_regex -lboost_system -lboost_thread -lpthread -lboost_chrono -lboost_date_time -lboost_atomic 
/usr/bin/ld: /usr/lib64/libfolly.a(Conv.cpp.o): warning: relocation against `_ZN5folly17BadExpectedAccessD1Ev' in read-only section `.text._ZN5folly15throw_exceptionINS_17BadExpectedAccessEEEvOT_[_ZN5folly15throw_exceptionINS_17BadExpectedAccessEEEvOT_]'
/usr/bin/ld: /usr/lib64/libfolly.a(String.cpp.o): relocation R_X86_64_PC32 against symbol `_ZTVSt9basic_iosIcSt11char_traitsIcEE@@GLIBCXX_3.4' can not be used when making a shared object; recompile with -fPIC
/usr/bin/ld: final link failed: bad value
collect2: error: ld returned 1 exit status

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01787146-fbthrift/

For all our attempts to build fbthrift with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/fbthrift/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Ben Cotton 2021-02-09 15:28:33 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.


Note You need to log in before you can comment on or make changes to this bug.